﻿Imports Telerik.Windows.Controls.ScheduleView
Imports Telerik.Windows.Controls

Namespace LightSwitchApplication
	Public Class CustomAppointment
		Inherits Appointment
		Implements IDataErrorInfo

		Private _product As Product
		Public Property Product() As Product
			Get
				Return Me.Storage(Of CustomAppointment)()._product
			End Get
			Set(value As Product)

				Dim storage = Me.Storage(Of CustomAppointment)()
				If Not Object.ReferenceEquals(Me._product, value) Then
					storage._product = value
					Me.OnPropertyChanged(Function() Me.Product)
				End If
			End Set
		End Property

		Public Overrides Function Copy() As IAppointment
			Dim newAppointment = New CustomAppointment()
			newAppointment.CopyFrom(Me)
			Return newAppointment
		End Function

		Public Overrides Sub CopyFrom(other As IAppointment)
			Dim task = TryCast(other, CustomAppointment)
			If task IsNot Nothing Then
				Me.Product = task.Product
			End If
			MyBase.CopyFrom(other)
		End Sub

		Public ReadOnly Property [Error] As String Implements System.ComponentModel.IDataErrorInfo.Error
			Get
				Return Me.ValidateProduct()
			End Get
		End Property

		Default Public ReadOnly Property Item(columnName As String) As String Implements System.ComponentModel.IDataErrorInfo.Item
			Get
				Select Case columnName
					Case "Product"
						Return Me.ValidateProduct()
				End Select

				Return Nothing
			End Get
		End Property

		Private Function ValidateProduct() As String
			If Me.Product Is Nothing Then
				Return "Product cannot be null!"
			End If
			Return Nothing
		End Function

		Protected Overrides Sub OnPropertyChanged(propertyName As String)
			MyBase.OnPropertyChanged(propertyName)

			If propertyName = "Product" Then
				CommandManager.InvalidateRequerySuggested()
			End If
		End Sub
	End Class
End Namespace
